//
//  BFRecordScreenImageManager.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2021/12/14.
//

import Foundation
import CoreMedia

class BFRecordScreenImageManager : BFRecordScreenBaseManager{
    
    override func resetEnv() {
        // 重置指针
        currentAssetProgress = .zero
        super.resetEnv()

    }
    
    override func startRecord() {
        super.startRecord()
    }
    
    override func play() {
        dele?.startPlayRecord(time: currentAssetProgress)
    }
    
    override func deleteRecord(at: CMTime) {
        
        // 注：删除录音后图片素材需要回撤指针进度,同时后面录音往前挪

        if let recordItem = recordItem {
            
            let old = recordItem.materialDuraion
            recordItem.materialDuraion = recordItem.voiceStickers.reduce(.zero, { partialResult, mod in
                partialResult + (mod.endCMTime - mod.startCMTime)
            })
            if let deletevoicemodel = dele?.events.last?.deletedVoices?.first {
                currentAssetProgress = deletevoicemodel.startCMTime
            }else{
                if CMTimeCompare(at, recordItem.materialDuraion) < 0 {
                    currentAssetProgress = at
                }else{
                    currentAssetProgress = recordItem.materialDuraion
                }
            }
            
            let currDuration = old - recordItem.materialDuraion
            // 更新进度
            dele?.resetCurrentProgress()
            
            
            for (index, item) in recordItem.voiceStickers.enumerated() {
                if index >= dele?.isStopAtRecordRange ?? 0 {
                    // 注：开始时间减去duration or 等一前一段录音的结束时间
                    item.startCMTime = item.startCMTime - currDuration
                    item.endCMTime = item.endCMTime - currDuration
                    
                    let titlsList = recordItem.titleStickers.filter { tm in
                        tm.recordId == item.recordId
                    }
                    
                    for titleM in titlsList {
                        titleM.timelineIn = titleM.timelineIn - currDuration
                        titleM.timelineOut = titleM.timelineOut - currDuration
                    }
                }
            }
            /// 重绘录音进度视图
            dele?.resetAllIndirectionView()
        }

        
    }
    
    override func changeRecordMaterail() {}
    
    override func clean() {
        super.clean()
        filter.removeTarget(playView)
        
    }
}
